﻿/******************************************************************************
Module:  App.xaml.cs
Notices: Copyright (c) by Jeffrey Richter and Wintellect
******************************************************************************/

using System;
using Windows.ApplicationModel;
using Windows.ApplicationModel.Activation;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Wintellect.WinRT.AppAids;
using Wintellect.WinRT.FramePageStateManager;

namespace BackgroundTransfer {
   public sealed partial class App : Application {
      private const String c_FramePageStateFileName = "FramePageState.xml";
      // Invoked because DISABLE_XAML_GENERATED_MAIN is defined:
      public static void Main(String[] args) {
         AppAid.Start(p => new App(), (f, a) => f.DeserializePageState(c_FramePageStateFileName, a));
      }

      public App() {
         this.InitializeComponent();
         this.Suspending += OnSuspending; // Raised when main view thread is being suspended
      }
      private void OnSuspending(Object sender, SuspendingEventArgs e) {
         // Invoked via main view thread when app is being suspended or closed by user
         AppAid.Log();

         // TODO: Save user session state in case app is terminated (see ApplicationData.Current.LocalFolder)
         AppAid.CurrentFrame.SerializePageState(c_FramePageStateFileName);
      }

      protected override async void OnLaunched(LaunchActivatedEventArgs args) {
         if (!await args.ActivateViewAsync()) {
            this.Navigate(typeof(BkgndTransferPage), args.Arguments);
         }
      }
      protected override async void OnActivated(IActivatedEventArgs args) {
         Boolean previousStateRestored = await args.ActivateViewAsync();
         args.OnActivatedForContinuation(((Frame)Window.Current.Content).Content);
         base.OnActivated(args);
      }
   }
}
